<template>
  <div class="wrapper">
    <div class="container-fuild">
      <div id="headTitle">
        <logo />
        <h1 id="title" _msttexthash="48503" _msthash="2">
          {{ i18ntext.lngText("permis") }}
        </h1>
      </div>
    </div>
    <Header />
    <ol id="topicPath">
      <li style="margin-left: 288px">
        <router-link to="productsetting">
          <a href="dashbaord">
            <font style="vertical-align: inherit">
              <font style="vertical-align: inherit">
                {{ i18ntext.lngText("permis") }}
              </font>
            </font>
          </a>
        </router-link>
      </li>
    </ol>
    <div class="search-box">
      <div id="product">
        <div class="search-box">
          <MenuBrand />
          <div class="search-box-title" style="padding-left: 9px">
            <router-link to="employee"
              ><a class="btn-radius btn btn-sm"
                href="#"
                style="color: #f8f5b4; margin-top: -2px"
              >
                <i class="fa fa-cog" aria-hidden="true"></i>
                {{ i18ntext.lngText("emp") }}
              </a></router-link
            >
            <router-link to="user"
              ><a
                class="btn-radius btn btn-sm"
                href="#"
                style="color: #f8f5b4; margin-top: -2px"
              >
                <i class="fa fa-cog" aria-hidden="true"></i>
                {{ i18ntext.lngText("user") }}
              </a></router-link
            >
            <router-link to="permission"
              ><a
                class="btn-radius btn btn-sm"
                href="#"
                style="
                  color: #f8f5b4;
                  margin-top: -2px;
                  background-color: #29a5a5;
                  border: #22adb763 1px solid;
                "
              >
                <i class="fa fa-cog" aria-hidden="true"></i>
                {{ i18ntext.lngText("permis") }}
              </a></router-link
            >
            <router-link to="role"
              ><a
                class="btn-radius btn btn-sm"
                href="#"
                style="color: #f8f5b4; margin-top: -2px"
              >
                <i class="fa fa-cog" aria-hidden="true"></i>
                {{ i18ntext.lngText("role") }}
              </a></router-link
            >
          </div>
          <div class="search-box-content">
            <table
              width="100%"
              border="0"
              cellpadding="0"
              cellspacing="0"
              class="tbl_search"
              id="hover-table"
            >
              <tbody>
                <tr>
                  <th width="10%">{{ i18ntext.lngText("role") }}</th>
                  <td width="50%">
                    <select
                      v-model="Per_form.role"
                      id="selRole"
                      @change="selectRole(Per_form)"
                    >
                      <option v-for="(x, z) in employees" :value="x.role" :key="z">
                        {{ x.role }}
                      </option>
                    </select>
                  </td>
                </tr>
                <tr>
                  <th width="10%">{{ i18ntext.lngText("description") }}</th>
                  <td width="50%">
                    <input autocomplete="off"
                      class="string_zen clear_text text input_text"
                      type="text"
                      style="width: 360px"
                      v-model="Per_form.description"
                    />
                  </td>
                </tr>
              </tbody>
            </table>
            <div class="search-box-footer">
              <div class="button type2" id="uniform-undefined" @click="updatePer()">
                <span>
                  <input autocomplete="off"
                    type="button"
                    class="type2"
                    tabindex="10025"
                    value="display"
                    style="opacity: 0; width: 54px"
                  /><i class="fa fa-save" aria-hidden="true"></i>
                  {{ i18ntext.lngText("update") }}
                </span>
              </div>
              <span class="marker"></span>
            </div>
          </div>
        </div>
        <div class="box mt-4">
          <table width="100%" class="table table-striped br-table">
            <thead>
              <tr class="header-table">
                <th
                  colspan="9"
                  style="text-align: start; cursor: pointer"
                  data-bs-toggle="collapse"
                  href="#General"
                >
                  Menu <i class="fa fa-chevron-down" aria-hidden="true"></i>
                </th>
              </tr>
            </thead>
            <tbody
              v-for="(name, index) in permisionts.dataMenu"
              :key="index"
              style="border: none"
              id="loop"
            >
              <tr
                id="General"
                data-bs-toggle="collapse"
                class="collapse tr"
                style="cursor: pointer"
              >
                <td>
                  <input autocomplete="off"
                    style="cursor: pointer"
                    type="checkbox"
                    :id="name.kye.toUpperCase() + '_ALL'"
                    :value="name.kye.toUpperCase() + '_ALL'"
                    hidde
                    v-model="checkedNames"
                  />
                  {{ name.name }}
                </td>
              </tr>
            </tbody>
          </table>
          <table width="100%" class="table table-striped br-table">
            <thead>
              <tr class="header-table">
                <th
                  colspan="9"
                  style="text-align: start; cursor: pointer"
                  data-bs-toggle="collapse"
                  href="#ProductSetting"
                >
                  Product Setting <i class="fa fa-chevron-down" aria-hidden="true"></i>
                </th>
              </tr>
            </thead>
            <tbody
              v-for="(name, index) in permisionts.dataProductSetting"
              :key="index"
              style="border: none"
              id="loop"
            >
              <tr
                id="ProductSetting"
                data-bs-toggle="collapse"
                class="collapse tr"
                style="cursor: pointer"
              >
                <td>
                  <input autocomplete="off"
                    style="cursor: pointer"
                    type="checkbox"
                    :id="name.kye.toUpperCase() + '_ALL'"
                    :value="name.kye.toUpperCase() + '_ALL'"
                    hidde
                    v-model="checkedNames"
                  />
                  {{ name.name }}
                </td>
              </tr>
            </tbody>
          </table>
          <table width="100%" class="table table-striped br-table">
            <thead>
              <tr class="header-table">
                <th
                  colspan="9"
                  style="text-align: start; cursor: pointer"
                  data-bs-toggle="collapse"
                  href="#Purchese"
                >
                Purchese<i class="fa fa-chevron-down" aria-hidden="true"></i>
                </th>
              </tr>
            </thead>
            <tbody
              v-for="(name, index) in permisionts.dataPurchese"
              :key="index"
              style="border: none"
              id="loop"
            >
              <tr
                id="Purchese"
                data-bs-toggle="collapse"
                class="collapse tr"
                style="cursor: pointer"
              >
                <td>
                  <input autocomplete="off"
                    style="cursor: pointer"
                    type="checkbox"
                    :id="name.kye.toUpperCase() + '_ALL'"
                    :value="name.kye.toUpperCase() + '_ALL'"
                    hidde
                    v-model="checkedNames"
                  />
                  {{ name.name }}
                </td>
              </tr>
            </tbody>
          </table>
          <table width="100%" class="table table-striped br-table">
            <thead>
              <tr class="header-table">
                <th
                  colspan="9"
                  style="text-align: start; cursor: pointer"
                  data-bs-toggle="collapse"
                  href="#Stock"
                >
                Stock <i class="fa fa-chevron-down" aria-hidden="true"></i>
                </th>
              </tr>
            </thead>
            <tbody
              v-for="(name, index) in permisionts.dataStock"
              :key="index"
              style="border: none"
              id="loop"
            >
              <tr
                id="Stock"
                data-bs-toggle="collapse"
                class="collapse tr"
                style="cursor: pointer"
              >
                <td>
                  <input autocomplete="off"
                    style="cursor: pointer"
                    type="checkbox"
                    :id="name.kye.toUpperCase() + '_ALL'"
                    :value="name.kye.toUpperCase() + '_ALL'"
                    hidde
                    v-model="checkedNames"
                  />
                  {{ name.name }}
                </td>
              </tr>
            </tbody>
          </table>
          <table width="100%" class="table table-striped br-table">
            <thead>
              <tr class="header-table">
                <th
                  colspan="9"
                  style="text-align: start; cursor: pointer"
                  data-bs-toggle="collapse"
                  href="#Phamacy"
                >
                Phamacy <i class="fa fa-chevron-down" aria-hidden="true"></i>
                </th>
              </tr>
            </thead>
            <tbody
              v-for="(name, index) in permisionts.dataPhamacy"
              :key="index"
              style="border: none"
              id="loop"
            >
              <tr
                id="Phamacy"
                data-bs-toggle="collapse"
                class="collapse tr"
                style="cursor: pointer"
              >
                <td>
                  <input autocomplete="off"
                    style="cursor: pointer"
                    type="checkbox"
                    :id="name.kye.toUpperCase() + '_ALL'"
                    :value="name.kye.toUpperCase() + '_ALL'"
                    hidde
                    v-model="checkedNames"
                  />
                  {{ name.name }}
                </td>
              </tr>
            </tbody>
          </table>
          <table width="100%" class="table table-striped br-table">
            <thead>
              <tr class="header-table">
                <th
                  colspan="9"
                  style="text-align: start; cursor: pointer"
                  data-bs-toggle="collapse"
                  href="#Report"
                >
                Report <i class="fa fa-chevron-down" aria-hidden="true"></i>
                </th>
              </tr>
            </thead>
            <tbody
              v-for="(name, index) in permisionts.dataReport"
              :key="index"
              style="border: none"
              id="loop"
            >
              <tr
                id="Report"
                data-bs-toggle="collapse"
                class="collapse tr"
                style="cursor: pointer"
              >
                <td>
                  <input autocomplete="off"
                    style="cursor: pointer"
                    type="checkbox"
                    :id="name.kye.toUpperCase() + '_ALL'"
                    :value="name.kye.toUpperCase() + '_ALL'"
                    hidde
                    v-model="checkedNames"
                  />
                  {{ name.name }}
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
  <div id="myModal" class="lskymodal">
    <div class="lskymodal-content">
      <p><i aria-hidden="true"></i> {{ massege }}</p>
    </div>
  </div>
  <UserInfo />
</template>
<script>
import axios from "axios";
import pagination from "laravel-vue-pagination";
import Header from "../Header.vue";
import Logo from "../logo.vue";
import Auth from "../../auth/Auth";
import UserInfo from "../UserInfo.vue";
import i18n from "../../i18n/i18n";
export default {
  components: { Header, pagination, Logo, UserInfo },
  directives: {
    print,
  },
  data() {
    return {
      i18ntext: i18n,
      checkedNames: [],
      employees: [],
      permisionts: {
        dataMenu: [
          // Menu Dashboard
          { name: "Product", kye: "Product" },
          { name: "Pharmacy", kye: "Pharmacy" },
          { name: "Labo", kye: "Labo" },
          { name: "Expenses", kye: "Expenses" },
          { name: "Company", kye: "Company" },
          { name: "Employee", kye: "Employee" },
          { name: "Report", kye: "Report" },
        ],
        // Product Setting
        dataProductSetting: [
          { name: "Brand", kye: "Brand" },
          { name: "Suppliyer", kye: "Suppliyer" },
          { name: "UnitType", kye: "UnitType" },
          { name: "Diangosis", kye: "Diangosis" },
          { name: "Category", kye: "Category" },
          { name: "ExchangeRate", kye: "ExchangeRate" },
          { name: "Payment", kye: "Payment" },
          { name: "Service", kye: "Service" },
          { name: "GroupService", kye: "GroupService" },
        ],

        //Purchese
        dataPurchese: [
          { name: "PurcheseOrder", kye: "PurcheseOrder" },
          { name: "ResceptOrder", kye: "ResceptOrder" },
          { name: "PaymentView", kye: "PaymentView" },
        ],
        //Stock
        dataStock: [
          { name: "StockOnhand", kye: "StockOnhand" },
          { name: "StockOnhandDate", kye: "StockOnhandDate" },
          { name: "BeginningStock", kye: "BeginningStock" },
          { name: "StockCount", kye: "StockCount" },
          { name: "StockTransection", kye: "StockTransection" },
          { name: "StockAlert", kye: "StockAlert" },
          { name: "ExpireAlert", kye: "ExpireAlert" },
        ],
        // Pharmacy
        dataPhamacy: [
            { name: "Patient", kye: "Patient" },
            { name: "Laboratory", kye: "Laboratory" },
            { name: "Prescription", kye: "Prescription" },
        ],
        // Report
        dataReport:[
            {name:'SaleReport',kye:'SaleReport'},
            {name:'CloseReport',kye:'CloseReport'},
            {name:'SaleItemReport',kye:'SaleItemReport'},
            {name:'StockinvenReport',kye:'StockinvenReport'},
            {name:'ExpensesReport',kye:'ExpensesReport'},
            {name:'IncomeReport',kye:'IncomeReport'},
            {name:'Income & Expen',kye:'In_ExReport'},






        ]
      },
      Per_form: {
        id: "",
        role: "",
        permission: "",
        description: "",
        created_by: "",
        updated_by: "",
      },
    };
  },
  mounted() {
    this.getSelectRole();
    this.loggedUser = Auth.user;
  },
  methods: {
    getSelectRole() {
      this.Per_form.created_by = Auth.user.id;
      this.Per_form.role = Auth.user.role;
      axios.post("api/v1/role/index", this.Per_form).then((res) => {
        this.employees = res.data;
        this.Per_form.role = "";
      });
    },

    selectRole(role) {
      role.created_by = Auth.user.id;
      axios
        .post("api/v1/permissionrole/getOne/" + this.Per_form.role, role)
        .then((res) => {
          this.Per_form = res.data;
          if (this.Per_form.permission != null) {
            this.checkedNames = this.Per_form.permission.split(",");
            this.massege = "Select Done.";
            this.messagebox();
          } else {
            this.checkedNames = [];
            this.massege = "Select was created.";
            this.messagebox();
          }
        });
    },
    updatePer() {
      this.Per_form.updated_by = Auth.user.id;
      this.Per_form.permission = this.checkedNames.join(",");
      axios.post("api/v1/permrole/update", this.Per_form).then((res) => {
        this.Per_form = {};
        this.checkedNames = [];
        console.log(this.checkedNames)
        console.log(this.Per_form)
        this.massege = "Update Successfully.";
        this.messagebox();
      });
    },
    messagebox() {
      var modal = document.getElementById("myModal");
      modal.style.display = "block";
      setTimeout(() => (modal.style.display = "none"), 1500);
    },
  },
};
</script>
